#!/usr/bin/env python
#############################################################################
# Copyright (C) DSTC Pty Ltd (ACN 052 372 577) 1997, 1998
# All Rights Reserved.
#
# The software contained on this media is the property of the DSTC Pty
# Ltd.  Use of this software is strictly in accordance with the
# license agreement in the accompanying LICENSE.HTML file.  If your
# distribution of this software does not contain a LICENSE.HTML file
# then you have no rights to use this software in any manner and
# should contact DSTC at the address below to determine an appropriate
# licensing arrangement.
# 
#      DSTC Pty Ltd
#      Level 7, GP South
#      Staff House Road
#      University of Queensland
#      St Lucia, 4072
#      Australia
#      Tel: +61 7 3365 4310
#      Fax: +61 7 3365 4311
#      Email: enquiries@dstc.edu.au
# 
# This software is being provided "AS IS" without warranty of any
# kind.  In no event shall DSTC Pty Ltd be liable for damage of any
# kind arising out of or in connection with the use or performance of
# this software.
#
# Project:      Fnorb
# File:         $Source: /cvsroot/fnorb/fnorb/script/fnlogger.py,v $
# Version:      @(#)$RCSfile: fnlogger.py,v $ $Revision: 1.1 $
#
#############################################################################
""" Logger. """

# Standard/built-in modules.
import signal, sys

# DSTC modules.
import Elvin


def callback(subscription_id, event):
    """ Event callback. """

    sys.stderr.write(event['Message'])
    sys.stderr.write('\n')

    return

def main(argv):
    """ Do it! """

    # Connect to the Elvin server.
    elvin = Elvin.Elvin()

    # Subscribe.
    elvin.subscribe('exists(ORB) && ORB == "Fnorb"', callback)

    # Wait!
    signal.pause()

    return 0

#############################################################################

if __name__ == '__main__':
    # Do it!
    sys.exit(main(sys.argv))

#############################################################################
